/*
 * John William Lynch
 * CSC 480 : A2
 * Please Read:
 * 
 * In my original code, I created three different classes, 
 * a dot, edge, and Board class. However, as I kept attempting
 * for a few days to get my recursive MiniMax algorithm to run
 * and effectively maintain various classes, it got too condense and 
 * I wasn't able to get my AI to work properly at all
 * Because of this, I decided to make my code more simplified and opted
 * to make code that just uses a board as an int[][] double array of
 * rows and columns, and do basic math in if / else statements 
 * to output if it was a specific item or not:
 * 
 */

package Assignment_2;

public class Board {
	
	//Variable for current board state
	int [][] currentBoard;
	
	//Variables for row and columns
	int rows;
	int columns;
	
	//Variables to maintain the score of both the player and ai
	int scoreForPlayer;
	int scoreForAI;
	
	//Variable to determine whose turn it is: if true == human, if false == ai
	boolean playerTurn;
	
	//This int acts as a val for comparisons within the miniMax function : it is the heuristic described in power slides
	int heuristicVal;
	
	
	//Constructor for the board : start and during gameplay
	//A board is an 2D int array to operates on a certain amount of requested rows and columns:
	//Needs to track the : two scores of each player, the amount of rows/columns, the current turn of the player
	public Board (int[][] currentBoard, int rows, int columns, boolean playerTurn, int scoreForPlayer, int scoreForAI) {
		this.currentBoard = currentBoard;
		this.rows = rows;
		this.columns = columns;
		this.playerTurn = playerTurn;
		this.scoreForPlayer = scoreForPlayer;
		this.scoreForAI = scoreForAI;
	}
	
	//Small heuristic comparator that compares the two scores of the human vs the ai
	public Integer differenceHueristic() { 
		return this.heuristicVal = this.scoreForPlayer - this.scoreForAI;
	}
	
	//Small function that allows the user to check whose turn it is via this return value: if this returns true, it is the Players turn, if false, it is the AI's turn
	public boolean whoseTurn() {
		return this.playerTurn;
	}
	//Two small utility functions that simply add onto the players score using a value found in the MIDDLE of an int array that 
	//had all four of its sides completed
	public void addToPlayer(int points) {
		this.scoreForPlayer += points;
	}
	
	public void addToAi(int points) {
		this.scoreForAI += points;
	}
	
	//Method to return the current board state for the user
	public int[][] getCurrentState(){
		return this.currentBoard;
	}
	
	//A final helper method that simply iterates through the board and checks if it is complete:
	//A board is complete when it has no 0 values left, as 0 indicates a position an item can go into
	public boolean isComplete() {
		
		for (int row = 0; row < rows; row ++) {
			for (int column = 0; column < columns; column++) {
				if (currentBoard[row][column] == 0) { 
					return false;
				}
			}
		
		}
		
	return true;
	}

	//Below are two UTILITY methods that simply print out the current state of the board and also print out the subsequent 
	//moves that are able to be done on that board
	
	/*
	 * A few explanations of my logic is described here:
	 * When I simply iterate through my board and print out the currentBoard[row][column], I get similar output like this:
	 *   
	 *   0005
	 *   
	 *   In every iteration of our row and column, we do a check to see if the value of the currentBoard[][] array is just a normal value,
	 *   or if it is a specially defined value that 
	 *   
	 *   From Main java, the output that I decided for each value to be was the following:
	 *   
	 *     0 == * or star
	 *    -1 == --- or horizontal line
	 *    -2 == | or vertical line
	 *    -3 == + or corner that is not changeable
	 *    
	 */
	public void displayBoard () {
		
		for (int row = 0; row < rows; row ++) {
			
			for (int column = 0; column < columns; column++) {
				
				//Check if the row and column equal a 0, because as described in logic earlier, a 0 means a star.
				if (currentBoard[row][column] == 0) { 
					System.out.print(" * " );
				}
				//Check if the row and column equal a -1, as that denotes a horizontal line
				else if(currentBoard[row][column] == -1) {
					System.out.print("---");
				}
				//Check if the row and column equal a -2, as that denotes a vertical line
				else if (currentBoard[row][column] == -2) {
					System.out.print(" | ");
				}
				//Check if the row and column are equal to -3, as -3 denotes a stagnant corner
				else if (currentBoard[row][column]== -3) {
					System.out.print(" + ");
				}
				//Otherwise, the value is not unique and it is an actual psuedo-random number that was generated.
				else {
					System.out.print(" " + currentBoard[row][column] + " ");
				}
			}
			//Print a new line at the end of every column so it is indented and displayed:
			System.out.print("\n");
		}		
		
	}
	
	/*
	 * Helper method to output a readable coordinate system to the user so they can make a decision about which element to
	 * place a line at: 0,0 is a corner piece, so those are skipped. The only items that are placed into the string are those of elements *
	 * There is no in-depth functionality with this method, it simply returns a string of possible moves
	 */
	public StringBuilder getPossibleMoves() {
		//Is unique to each board, so no need to pass in a variable, once this function is called the basic 
		
		StringBuilder possibleMoves = new StringBuilder();
		
		for (int row = 0; row < rows; row ++) {
			
		
			for (int column = 0; column < columns; column++) {
			
				//Check if the row and column equal a 0, because as described in logic earlier, a 0 means a star.
				if (currentBoard[row][column] == 0) { 
					//Append the found row and column numbers into a list of coordinates:
					possibleMoves.append("(" + row + " , " + column + ")");
				}
			}
		}	
		//Return the newly created list of coordinates
		return possibleMoves;
	}
	
	//Methods to be called while the game is running:
	
	//Helper method that determines if the user entered X and Y in the while loop of my Main.java class is acceptable 
	//by checking if the inputted x and y are equal to a 0 : or a * 
	
	public boolean checkProperInput(int row, int column) {
		System.out.println("In check proper input");
		System.out.println(row);
		System.out.println(column);
		if (currentBoard[row][column] == 0) {
			return true;
		}
		else {
			return false;
		}
		
	}
	
	//Helper method that will return to the user if they have selected to input a horizontal line or a vertical line:
	/*
	 * To reiterate how to determine if a line is horizontal or vertical, we need to recall that on a 2x2 plane,
	 * 
	 *   + * + * + row 0
	 *   * 1 * 2 * row 1
	 *   + * + * + row 2
	 *   * 3 * 1 * row 3
	 *   + * + * + row 4
	 *   0 1 2 3 4
	 *   Whenever we see an even row requested and and odd column requested, the only possible places 
	 *   that we can place those are beneath or above a number, therefore that will be a HORIZONTAL line
	 *   
	 *   Whenever we see an even row requested with an odd column, or in general an odd row (look at row 1, row 3)
	 *   
	 *   the only areas we can place an item in are within those constraints are Vertically, so it will be a VERTICAL line
	 *   
	 *   This can be simplified further, as we see whenever we choose an even row with an even column, it is outside of our
	 *   allowed bounds (it hits the PLUS sign rather than an *)
	 *   
	 *   So this can be simplified to : if Row is even, it is horizontal, if Row is odd, it is vertical
	 *   
	 **/
	public LineType requestedLineType(int row, int column) {
		//We assume we passed the checkProperInput at this point,
		//so we can do a simple if/else here 
		
		//Check if row is even and thus it is horizontal
		if (row % 2 == 0) {
			return LineType.HORIZONTAL;
		}
		else {
			return LineType.VERTICAL;
		}
		
	}
	
	//The following are the methods for checking a box for completion
	//I encapsulated the strategies in four separate methods, because I found a huge single if / else clause would be confusing:
	/*
	 * 1. Check if horizontal line in middle box completes box
	 * 2. check if vertical line in middle box completes box
	 * 3. check if horizontal line in outermost box completes box (ie: line with row = 0 or row = rows-1)
	 * 4. check if vertical line in outermost box completes box (ie : line with col = 0 or col = col - 1)
	 * 
	 */
	//This is the method that will be used by the user after their turn, it will use the following logic to check if any boxes have been created:
	/*
	 * it is a bit intensive to do a large if / else statement check to see if boxes have been completed, but as we are using a 2D int array we have to rely
	 * on if else statements to check the columns around 
	 * 
	 * A single middle board example of checking for an updated value:
	 *  
	 *   + * +
	 *   | 4 |
	 *   +---+
	 *   
	 *   The below logic is restricted to just lines that are selected that are in the middle of the board
	 *   The lines that are on the very outermost edges (such as topmost, bottom most, leftmost and rightmost) have
	 *   a slightly different logic that I describe after this logic
	 *  
	 *  If we take the above as a 2D array, we can check if row [0][1] is available and insert a horizontal line
	 *  After we insert this horizontal line, we need to check the subsequent LEFT, RIGHT, and BOTTOM sides of this box
	 *  in order to attest that all three of the other ones do NOT equal 0 (ie : are equal to a Blank *) and then we can 
	 *  determine that the box is fully complete
	 *  
	 *  To do this, we need to do some jumping around via our indices. Because we are in a 2D array and we know that our numbers
	 *  (the psuedo-random numbers) are always in the middle, and we have a special value of -3 to indicate the CORNERS of a box,
	 *  we do not need to worry about any index out of bounds errors
	 *  
	 *  Having this idea, we can take some scenarios from the single box above : 
	 *  As soon as that line is inserted, we need to check the opposite horizontal line and its other two vertical lines
	 *   - For horizontal: row = row + 2  :  col = col
	 *   - For left Column : row = row + 1 : col = col - 1
	 *   - For Right Column : row = row + 1 : col = col + 1
	 *  
	 *  This checks the boxes that are below it only, to check the ones above it we would do
	 *   - For horizontal: row = row  - 2  :  col = col
	 *   - For left Column : row = row - 1 : col = col - 1
	 *   - For Right Column : row = row - 1 : col = col + 1
	 * 
	 * 
	 * For vertical lines, this logic can apply:
	 * 
	 *  - For 
	 *  
	 *  
	 *  
	 *  
	 *  
	 * 
	 * As stated earlier, the logic for the edges are a bit different again: if we take the above 4 box and instead make it seem like it is on the edge
	 * we then only need to check the box directly below it
	 * 	 + * +
	 *   | 4 |
	 *   +---+
	 *   
	 *   -For horizontal : row = row + 2  : col = col
	 *   -For left Column : row = row + 1 : col = col - 1
	 *   -For right column : row = row + 1 : col = col + 1
	 * 
	 *  Likewise, if we have a horizontal line at the very bottom (ie : row = rows - 1 (last index )) we just need to check for a box right above us:
	 * 	 +---+
	 *   | 4 |
	 *   + * +
	 *  
	 *   -For horizontal : row = row - 2  : col = col
	 *   -For left Column : row = row - 1 : col = col - 1
	 *   -For right column : row = row - 1 : col = col + 1
	 * 
	 * The extra checking for which methods of these to use is done within the while loop of Main.java class
	 */
	
	//Method for checking edge box for completion:
	public void checkEdgeHorizontalBox(int row, int column) {
		//Ensure that it is an actual edge horizontal box with if statements

		//Check top-most row:
		if (row == 0) {
			if (currentBoard[row+2][column] == -1 && currentBoard[row+1][column-1] == -2 && currentBoard[row+1][column+1] == -2) {
				//It is the player's turn, give them the points: the points are located one to the left of the rightmost side
				if (this.playerTurn == true) {
					this.scoreForPlayer += currentBoard[row+1][column];
					System.out.println("You scored! Your current points: " + this.scoreForPlayer);
				}
				else {
					this.scoreForAI += currentBoard[row+1][column];
					System.out.println("AI scored! AI current points: " + this.scoreForAI);
				}
			}
		}
		//Check if row is equal to the bottom most row value
		else if (row == rows - 1) {

			if (currentBoard[row-2][column] == -1 && currentBoard[row-1][column-1] == -2 && currentBoard[row-1][column+1] == -2) {
				//It is the player's turn, give them the points: the points are located one to the left of the rightmost side
				if (this.playerTurn == true) {
					this.scoreForPlayer += currentBoard[row-1][column];
					System.out.println("You scored! Your current points: " + this.scoreForPlayer);
				}
				else {
					this.scoreForAI += currentBoard[row-1][column];
					System.out.println("AI scored! AI current points: " + this.scoreForAI);
				}
			}
		}
	}
	
	//Method for checking middle box for completion when horizontal line called
	public void checkMiddleHorizontalBox(int row, int column) {
		//Check neighboring lines using above logic, assuming we need to check both a top and bottom neighbor
		
		//Check the bottom neighbor
		if (currentBoard[row+2][column] == -1 && currentBoard[row+1][column-1] == -2 && currentBoard[row+1][column+1] == -2) {
			if (this.playerTurn == true) {
				this.scoreForPlayer += currentBoard[row+1][column];
				System.out.println("You scored! Your current points: " + this.scoreForPlayer);
				
			}
			else {
				this.scoreForAI += currentBoard[row+1][column];
				System.out.println("AI scored! AI current points: " + this.scoreForAI);
			}
		}
		//Check the top neighbor
		else if (currentBoard[row-2][column] == -1 && currentBoard[row-1][column-1] == -2 && currentBoard[row-1][column+1] == -2) {
			if (this.playerTurn == true) {
				this.scoreForPlayer += currentBoard[row-1][column];
				System.out.println("You scored! Your current points: " + this.scoreForPlayer);
			}
			else {
				this.scoreForAI += currentBoard[row-1][column];
				System.out.println("AI scored! AI current points: " + this.scoreForAI);
			}
		}
	}
	
	
	/*
	 * For the Vertical classes, the exact same logic as the horizontal logic applies, however we are just tackling it from a different angle
	 * 
	 * For the outermost classes of a column, it won't be TOP or BOTTOM, rather it would be LEFT or RIGHT, as that is there respective sides
	 * where they end
	 * 
	 *  We can start with the logic for the LEFT-most side of a column if it is a line that is placed there:
	 *   +---+
	 *   * 4 |
	 *   +---+
	 *  
	 *   If we are on this left-most side, we only need to check if we are connect to other lines by checking our opposite column value,
	 *   the opposite 
	 *   
	 *   To check these values, we simply need to do
	 *   
	 *   For other column :  row = row : col = col + 2
	 *   For top row :  row = row -1 : col = col + 1
	 *   For bottom row : row = row + 1 : col = col + 1
	 *   
	 *   For the RIGHT-most side, we can simply call the opposite of these values 
	 *   +---+
	 *   | 4 *
	 *   +---+
	 *   For other column :  row = row : col = col -2
	 *   For top row :  row = row -1 : col = col - 1
	 *   For bottom row : row = row + 1 : col = col - 1
	 *   
	 *  For a middle boxed edge check the following logic can be applied
	 *   +---+
	 *   * 4 |
	 *   +---+
	 *  We need to not only check the right column and the horizontal lines, but also our left side column and horizontal lines,
	 *  so the logic would be as:
	 *  
	 *   For other column :  row = row : col = col -2
	 *   For top row :  row = row -1 : col = col - 1
	 *   For bottom row : row = row + 1 : col = col - 1
	 *  
	 *   For other column :  row = row : col = col + 2
	 *   For top row :  row = row -1 : col = col + 1
	 *   For bottom row : row = row + 1 : col = col + 1
	 *   
	 *   Simply combining the vertical edges logic into an if / else statement when it is not at the edges
	 */
	
	//Method for checking edge box for completing when vertical line added
	public void checkEdgeVerticalBox(int row, int column) {
		//Check if it is in the very first column
		if (column == 0) {
			//These checks if all values are completed and at the numerical representation of a completed edge or line
			if (currentBoard[row][column+2] == -2 && currentBoard[row-1][column+1] == -1 && currentBoard[row+1][column+1] == -1) {
				//It is the player's turn, give them the points: the points are located one to the right of the leftmost side
				if (this.playerTurn == true) {
					this.scoreForPlayer += currentBoard[row][column+1];
					System.out.println("You scored! Your current points: " + this.scoreForPlayer);
				}
				else {
					this.scoreForAI += currentBoard[row][column+1];
					System.out.println("AI scored! AI current points: " + this.scoreForAI);
				}
			}
		}
		else if (column == columns - 1) {
			//These checks if all values are completed and at the numerical representation of a completed edge or line
			if (currentBoard[row][column-2] == -2 && currentBoard[row-1][column-1] == -1 && currentBoard[row+1][column-1] == -1) {
				//After we see it is completed, grab the value that is located in the middle of it all and assign it to whose turn it is:
				
				//It is the player's turn, give them the points: the points are located one to the left of the rightmost side
				if (this.playerTurn == true) {
					this.scoreForPlayer += currentBoard[row][column-1];
					System.out.println("You scored! Your current points: " + this.scoreForPlayer);
				}
				else {
					this.scoreForAI += currentBoard[row][column-1];
					System.out.println("AI scored! AI current points: " + this.scoreForAI);
				}
			}
		}
	}
	
	//Method for checking middle box for completing when vertical line called : simply combines the above logic without the statements to check if it is a left most side 
	//or right most side column
	public void checkMiddleVerticalBox(int row, int column) {
		if (currentBoard[row][column+2] == -2 && currentBoard[row-1][column+1] == -1 && currentBoard[row+1][column+1] == -1) {
			//Add the score to the respective players based on whose turn it is
			if (this.playerTurn == true) {
				this.scoreForPlayer += currentBoard[row][column+1];
				System.out.println("You scored! Your current points: " + this.scoreForPlayer);
			}
			else {
				this.scoreForAI += currentBoard[row][column+1];
				System.out.println("AI scored! AI current points: " + this.scoreForAI);
			}
		}
		
		else if (currentBoard[row][column-2] == -2 && currentBoard[row-1][column-1] == -1 && currentBoard[row+1][column-1] == -1) {
			//It is the player's turn, give them the points: the points are located one to the left of the rightmost side
			if (this.playerTurn == true) {
				this.scoreForPlayer += currentBoard[row][column-1];
				System.out.println("You scored! Your current points: " + this.scoreForPlayer);
			}
			else {
				this.scoreForAI += currentBoard[row][column-1];
				System.out.println("AI scored! AI current points: " + this.scoreForAI);
			}
		}
	}
	
	
}