/*
 * John William Lynch
 * CSC 480 : A2
 * Main Driver of Assignment 2 Program
 */
package Assignment_2;

import java.util.Random;
import java.util.Scanner;

/*
 * As noted in a few of my other .java files attached, the last few days I spent on my other
 * attempts make this run using an edge, dot, and box class did not end up working properly, 
 * therefore I scratched those ideas and restarted using just a simple 2D matrix of integers 
 * to see if I can successfully create a matrix
 */
public class Main {
	
	//Define two string methods for ease of reference for throughout the code:
	String horizontal = "---";
	String vertical = " | ";
	
	public static void main (String[] args) {
		System.out.println("John William Lynch : CSC 480 A2 : Updated Assignment 2");
		
		//Simple print and next() statements to get user information requested
		System.out.println("Please select in NxN the size of the board (IE: 2x2, or 5x5): ");
		Scanner userInput = new Scanner(System.in);
		String requestedBoard = userInput.next();
		
		//Split the value of the requestedBoard (that is a string) into respective row and columns:
		String[] requestedValues = requestedBoard.split("x");
		int rows = Integer.parseInt(requestedValues[0]);
		int columns = Integer.parseInt(requestedValues[1]);
		
		System.out.println("Please specify how many plys the AI will search (IE: 3): ");	
		String requestedPly = userInput.next();
		
		//Check who goes first:
		boolean playerTurn = true;
		
		//Using the requested rows and columns, generate a grid of only DOTS and randomly generated node numbers that will
		//be maintained in a board (ie: an int[][] called currentBoard)
		
		//A quick note, is that if we simply create a board based off of the given row and column number, we get a board that is too small
		//ie: a 2x2 entry by the user will only generate a board that is of size 4:
		/*
		 * Please Note: All of my grids consist of a PLUS Sign at the CORNERS dots of my grid, and the reason is that you are not allowed
		 * to place in a value at the corners. They are simply there for consistency sake so that it feels more like a gride.
		 * 
		 * The areas with asterisks or * are where the horizontal and vertical lines will be placed.
		 * 
		 * To calculate the size of the board, we can determine the output of any entry in relation to how many objects in the int array
		 * that there will be. When viewing a 1x1 board (with only one item, we can see it as the following: 1x1 board
		 * 
		 *  + * +
		 *  * 2 *
		 *  + * +
		 *  
		 *  We see that, from the above, we have a 3 x 3 column length (via stars) surrounding every edge of our item, if we do 1 x 1
		 *  
		 *  + * + * +
		 *  * 1 * 2 *
		 *  + * + * +
		 *  * 3 * 4 *
		 *  + * + * +
		 *  
		 *  We see that, from the above, we have a 5x5 column length length (via stars) surrounding every edge of our item when we do 2x2 
		 *  
		 *  
		 *  + * + * + * +
		 *  * 1 * 2 * 1 *
		 *  + * + * + * +
		 *  * 3 * 4 * 4 *
		 *  + * + * + * +
		 *  * 5 * 1 * 4 *
		 *  + * + * + * +
		 *  
		 *  We see that, from the above, we have a 7x7 column length length (via stars) surrounding every edge of our item when we do 3x3
		 *  
		 *  In each iteration, for an n x n board, the way that we acquire the N from the user given variable is by multiplying it by 2 and then adding 1, let's test
		 *   1 x 2 = 2 + 1 = 3  (for 1x1)
		 *   2 x 2 = 4 + 1 = 5  (for 2x2)
		 *   3 x 3 = 6 + 1 = 7  (for 3x3)
		 *   
		 */
		
		//Using the above logic, when we create our actual game board, we must not only times each row and column by 2, but also add 1 to it
		rows = rows * 2 + 1;
		columns = columns * 2 + 1;
		int[][] currentBoard = new int[rows][columns]; //Makes this a 2D array, ie : a grid.
	
		/*
		 * Logic behind printing out for loop this way: if we have a 2 x 2 Board, we have dots like so in our array
		 * 	Reminder that the + symbolizes a corner which is not an edge, it just simply acts as a nice alternative to a blank space
		 * 
		 *    * * * * *
		 *    * * * * *
		 *    * * * * *
		 *    * * * * *
		 *    * * * * *
		 *    
		 *    //Now if we fill this with psuedo-random numbers
		 *    * * * * * #row0
		 *    * 1 * 5 * #row1
		 *    * * * * * #row2
		 *    * 8 * 6 * #row3
		 *    * * * * * #row4
		 * If this was an int array, we see that the values of of int[0][0], int[0][1], int[0][2] should all be star values:
		 * Meaning if the value of the ROW is an even number (as you see, row 1 and row 3 both have numbers inside of them)
		 * Then we should just create these to be star values that will be changed eventually once our algorithm goes over them
		 * 
		 * We can also see that in every column, when the column is at column 0, we have all stars, as described here:
		 * 	  
		 *    + * + * +  #row0
		 *    * 1 * 5 *  #row1
		 *    + * + * +  #row2
		 *    * 4 * 3 *  #row3
		 *    + * + * +  #row4
		 *    0 1 2 3 4
		 *    
		 *   The column numbers are associated with the very bottom : if we view this chart, at every location our column falls with an even row, we 
		 *   see that there is just a row of stars up and down.
		 *   However, when the column is at an ODD number (such as column 1) and the row is at an ODD number, we can then create a NUMBER that is psuedo-random (1 to 5)
		 *   
		 *   Therefore, the following rules can be discerned:
		 * 
		 *    1) EVEN ROW, ODD COLUMN = Only edge
		 *    2) ODD ROW, EVEN COLUMN = Only edge
		 *    2) ODD ROW, ODD COLUMN = The actual number will appear
		 *   
		 * 
		 * The problem is that the array is of int[][], so it is impossible to store string values to be at certain locations, then 
		 * to solve this we can simply use a placeholder-variables to be an int in that location. 
		 * 
		 * However, there is another catch to doing this, as if we use placeholder-integers and use the values stored between 1 and 5, our code will detect the
		 * psudeo-random numbers in there proper locations (of an Odd Row, Even Column) and also replace them with an asterik, therefore we need to use numbers 
		 * that are outside of the scope of 1 to 5. 
		 * 
		 * I defaulted to simply using the following two:
		 * 
		 *     0 == * or star
		 *    -1 == --- or horizontal line
		 *    -2 == | or vertical line
		 *    -3 == + or corner that is not changeable
		 * 
		 */
		
		//Use a double nested for loop to fill in the array for rows and columns:
		for (int row = 0; row < rows; row ++) {
			for (int column = 0; column < columns; column++) {
				
				//Check if the row is odd, and then if the column is odd, if they are, we know it is a psuedo-random number location based off above logic
				if (row % 2 != 0 && column % 2 != 0) {
					//Helper method for creating a psuedo-random variable, explained below:
					currentBoard[row][column] = getRandInt(1,5);
				}
				//Check if we have an Odd Row and an Even Column, if it is add a star to determine the edge
				else if (row % 2 != 0 && column % 2 == 0) {
					//Simply add a star to the overall value : ie, a 0
					currentBoard[row][column] = 0;
				}
				//Check if we have an Even Row and an Odd Row, if it is add a star to determine the edge
				else if (row % 2 == 0 && column % 2 != 0) {
					//Simply add a star to the overall value : ie, a 0
					currentBoard[row][column] = 0;
				}
				//For any other scenarios, simply add a corner piece as the corner is not going to be modified by the user
				else {
					currentBoard[row][column] = -3;
				}
			}
		}
		
		//Pass the requested items over to a Board object:
		Board newGame = new Board(currentBoard, rows, columns, playerTurn, 0, 0);
		
		//Simply display the board for testing
		
		/*
		 * The game will run for as long as there are lines to be filled in, o determine the overall amount of lines that need to be filled in.
		 * Find the newly calculated amount of dots from previous logic where we used
		 * rows = rows * 2 + 1 == returned overall amount of rows
		 * columns = columns * 2 + 1 == returned overall amount of columns
		 * 
		 * To determine the amount of lines, take a 1 x 1:
		 * * * *
		 * * 1 *
		 * * * *
		 * 
		 * We see that we have 4 lines we can draw, if using the (ignoring the corner cases as they are just there for purposes of connectivity 
		 * 
		 * To calculate this programmatically, we can check the amount of rows and columns, times them together, then divide that by 2
		 * For a 1x1, this would give us  3x3 dots, and then 3 x 3 = 9. Dividing 9 / 2 = 4 (because of truncutation)
		 * Now, we end up with Four Lines, which seeing our 1x1 makes sense, as 4 lines are the only edges and top moves we can make:
		 * 
		 * * - *
		 * | 4 |
		 * * - *
		 * 
		 */
		int totalLines = (rows * columns) / 2;
		
		//Initialize a counter variable that will always take in the current amount of lines that are on the board, and then compare them to totalPossibleLines
		int currentLines = 0;
		
		//Initalize a root node that will be updated throughout the game:
		BoardNode root = new BoardNode(newGame);
		
		
		//Initialize a while loop that will run until the currentLines == totalLines
		//This is the start of our game:
		System.out.println("=====GAME START=====");
		root.currentBoard.displayBoard();
		while (currentLines < totalLines) { 
			
			//Determine which user will go first based on the input from the very start:
			
			//Human plays
			if (playerTurn == true) {
				newGame.playerTurn = true;
				//Below is the logic for the human turn : it consists of prompting the user for a specific row and column combination and then 
				
				//Present to the user the current board and possible moves associated with that board
				
				System.out.println("Possible Moves: " + newGame.getPossibleMoves());
				System.out.println("Players turn: ");
				
				//First, create a x and y int value holder to later pass over to our int[][] array
				int xChoice = 0;
				int yChoice = 0;
				
				//Ask the user for their X and Y coordinate choice off of the possible moves provided
				System.out.println("Please enter X: ");
				xChoice = userInput.nextInt();
				System.out.println("Please enter Y: ");
				yChoice = userInput.nextInt();
				
				
				//Double check that they are inputting acceptable coordinates that will enter to 0
				while (newGame.currentBoard[xChoice][yChoice] != 0) {
					System.out.println("Improper input! Please try again");
					System.out.println("Please enter X: ");
					xChoice = userInput.nextInt();
					System.out.println("Please enter Y: ");
					yChoice = userInput.nextInt();
					
				}
				
				//Check if the option they selected was vertical or horizontal by relying on function in Board.java
				LineType requestedDirection;
				requestedDirection = newGame.requestedLineType(xChoice, yChoice);
				
				//After grabbing the direction, determine if you need to set the new row / column variable 
				//to -1 for a horizontal line, or -2 for a vertical line
				if (requestedDirection.equals(LineType.HORIZONTAL)) {
					//Add a horizontal line
					newGame.currentBoard[xChoice][yChoice] = -1;
					//Check if we need to update the score if this move completes a full box : update method located in Board.java
					
					//First, check if this is a bottom or top horizontal line and use that specific method
					if (xChoice == 0 || xChoice == rows - 1) {
						newGame.checkEdgeHorizontalBox(xChoice, yChoice);
					}
					//Otherwise, use the basic horizontal method for other horizontal lines
					else {
						newGame.checkMiddleHorizontalBox(xChoice,yChoice);
					}
				}
				else if (requestedDirection.equals(LineType.VERTICAL)) {
					//Add a horizontal line
					newGame.currentBoard[xChoice][yChoice] = -2;
					
					//First, check if this is a left or right vertical line and use that specific method
					if (yChoice == 0 || yChoice == columns - 1) {
						newGame.checkEdgeVerticalBox(xChoice, yChoice);
					}
					//Otherwise, use the basic vertical method for other vertical lines
					else {
						newGame.checkMiddleVerticalBox(xChoice,yChoice);
					}
				}
				
				root.setBoard(newGame);
				//We need to reach an end state, so we need to increase the amount of lines found 
				//because we need to eventually reach the max number of allowed lines
				
				currentLines = currentLines + 1;
				//Swap the boolean so the other player may take their turn:
				playerTurn = false;				
			}
			
			//AI plays
			if (playerTurn == false) {
				newGame.playerTurn = false;
				//Call the MiniMax function on the current game board

				
				//Grab the coordiantes
				MiniMax aiMove = new MiniMax(newGame, Integer.parseInt(requestedPly));
				//Now run that function: this function returns an int array that we can then convert into xChoice and yChoice logic again
				int [] aiChoice = aiMove.run(root, Integer.parseInt(requestedPly));
				
				int xChoice = aiChoice[0];
				int yChoice = aiChoice[1];
				
				
				//Check if the option they selected was vertical or horizontal by relying on function in Board.java
				LineType requestedDirection;
				requestedDirection = newGame.requestedLineType(xChoice, yChoice);
				
				//After grabbing the direction, determine if you need to set the new row / column variable 
				//to -1 for a horizontal line, or -2 for a vertical line
				if (requestedDirection.equals(LineType.HORIZONTAL)) {
					//Add a horizontal line
					newGame.currentBoard[xChoice][yChoice] = -1;
					//Check if we need to update the score if this move completes a full box : update method located in Board.java
					
					//First, check if this is a bottom or top horizontal line and use that specific method
					if (xChoice == 0 || xChoice == rows - 1) {
						newGame.checkEdgeHorizontalBox(xChoice, yChoice);
					}
					//Otherwise, use the basic horizontal method for other horizontal lines
					else {
						newGame.checkMiddleHorizontalBox(xChoice,yChoice);
					}
				}
				else if (requestedDirection.equals(LineType.VERTICAL)) {
					//Add a horizontal line
					newGame.currentBoard[xChoice][yChoice] = -2;
					
					//First, check if this is a left or right vertical line and use that specific method
					if (yChoice == 0 || yChoice == columns - 1) {
						newGame.checkEdgeVerticalBox(xChoice, yChoice);
					}
					//Otherwise, use the basic vertical method for other vertical lines
					else {
						newGame.checkMiddleVerticalBox(xChoice,yChoice);
					}
				}
				
				root.setBoard(newGame);
		
				currentLines = currentLines + 1;
				//Swap the boolean so the other player may take their turn:
				playerTurn = true;
			}
			root.currentBoard.displayBoard();
		}
		
		System.out.println("Game completed...");
		System.out.println("Humans scored: " +  newGame.scoreForPlayer);
		System.out.println("AI scored: " +  newGame.scoreForAI);
		
		if (newGame.scoreForPlayer > newGame.scoreForAI) {
			System.out.println("Good job! You won!");
		}
		else if (newGame.scoreForAI > newGame.scoreForPlayer){
			System.out.println("Good try! The AI won!");
		}
		else {
			System.out.println("A draw occured!");
		}
	}
	
	//This is a helper function method using the built in java random tools that modifies it so the random range doesn't start from
	//0 to max (inclusive, exclusive), rather it uses a to b (inclusive, inclusive) in order to get a random value between 1 and 5 effectively
	private static int getRandInt(int a, int b) {
			
		Random rand = new Random();
		return rand.nextInt((b-a)+1) + a;
			
	}

}





















